#!/bin/bash
# $Revision: 1.16 $
# STANDARD 1.0
# PLUGIN TYPE:PASSWORD
# PLUGIN LIST:irc.DarkSin.ch #ZooDyaCo

######################################################################
echo "BEGIN: $(basename $0) $*" >&2
######################################################################
# Questo e' un "bash script plug-in" per BuDuScRiPt/budus_xdcc.sh

# Il suo scopo e' quello di fornire un "motore di ricerca".

######################################################################
# Include la Libreria di Funzioni XDCC
source $(dirname ${0})/budus_XBSPSE_LIB.sh

######################################################################
# Lo script "budus_xdcc.sh" invoca questo script passando, come primo
# parametro, un codice casuale che serve per calcolare il file dentro
# al quale immagazzinare il risultato opportunamente filtrato.
RANDOM_NUMBER=${1}

# Il secondo parametro e' il numero di secondi d'attesa del risultato
# dal sito web interrogato, trascorsi i quali, si deve interrompere la
# ricerca del plug-in.
WGET_TIMEOUT=${2}

# Il terzo parametro rappresenta la "stringa di ricerca" immessa
# dall'utente.
SEARCH_STRING=${3}

######################################################################
# VARIABILI AD USO DEL FILTRO
######################################################################
db_url_pre=""
db_url_post="/index.php?pass="
wget_option="--user-agent 'BuDuScRiPt plugin' -q -t 1 -O - -T ${WGET_TIMEOUT}"

######################################################################
# Vengono create e inizializzate le variabili base operative.
make_plugin_variables "${0}"

######################################################################

# Questo plug-in, scaricando una lista anziche' interrogando un motore
# di ricerca web, lavore in modo diverso: salva il risultato
# "giornaliero" (cioe' lo aggiorna solo una volta al giorno)
if [ -f /tmp/budus_XDCC_db_${plugin_name}.${date_code} ]; then
    make_data_file_exchange

    rm -f ${plugin_tempfile}    
    echo "END  : $0 $*" >&2
    exit 0;
else
    rm -f /tmp/budus_XDCC_db_${plugin_name}.*
fi

######################################################################
# URL ADS con cui ottenere la password.
ads_url="http://www.budus.ilbello.com/"

######################################################################
# VARIABILI AD USO DEL CRAWLER
######################################################################
crawler_server_host="irc.DarkSin.ch"
crawler_server_port="6667"
crawler_server_channel="#ZooDyaCo"
crawler_bot_nickname="ZooDC|LiST"
crawler_greeting_string='Ciao a tutti quanti
!list'
crawler_query_nickname="${crawler_bot_nickname}"
crawler_query_string="${ads_url}"
crawler_string_pattern="http://lista.zoodyaco.org/"

######################################################################
# Dato che il database non e' presente, deve interrogare il BOT del
# canale per ottenere la password di accesso.
get_list_password

db_url_pre=$(echo "${XBSPSE_Crawler}" \
    | grep -io "${crawler_string_pattern}" \
    | tail -n1)

PASSWORD=$(echo "${XBSPSE_Crawler}" \
    | grep -iF "${db_url_pre}" \
    | tail -n1 \
    | sed 's@http://@\nhttp://@' \
    | tr ' ' '\n' \
    | grep -iF "${db_url_pre}" \
    | sed 's@.*=@@' \
    | grep -o '[a-zA-Z0-9]*')

######################################################################
if [ "${PASSWORD}" == "" ]; then
    printf '[XBSPSE PLUGIN] %s: Non sono riuscito a contattare il BOT [%s:%s:%s] per ottenere la password; devo abortire.\n' "${plugin_name}" "${crawler_server_host}" "${crawler_server_channel}" "${crawler_bot_nickname}" >&2
    [ "${XBSPSE_Crawler}" != "" ] && \
	printf '/ECHO %s\n' "${XBSPSE_Crawler}" || \
	printf '/ECHO Il crawler non ha ottenuto risposta dal BOT %s\n' "${crawler_bot_nickname}"
    printf '/ECHO Se il problema persiste, si consiglia di contattare UDA'\''Software.\n'
    rm -f ${plugin_tempfile}
    get_XBSPSE_TIMEOUT "${XBSPSE_Crawler_ID}" > /dev/null
    queue_connection_manager "RELEASE"
    
    [ -f ${plugin_tempfile} ] && rm -f ${plugin_tempfile}
    
    exit 1
fi

WGET_TIMEOUT=$(get_XBSPSE_TIMEOUT "${XBSPSE_Crawler_ID}")

printf '[XBSPSE PLUGIN] %s: La password per accedere al database (%s) risulta essere %s e rimangono %d secondi prima del timeout.\n' "${plugin_name}" "${db_url_pre}#${db_url_post}" "${PASSWORD}" "${WGET_TIMEOUT}" >&2

######################################################################
wget ${wget_option} ${db_url_pre}1${db_url_post}${PASSWORD} | sed 's/\r//g'   > ${plugin_tempfile}
wget ${wget_option} ${db_url_pre}2${db_url_post}${PASSWORD} | sed 's/\r//g'  >> ${plugin_tempfile}
wget ${wget_option} ${db_url_pre}3${db_url_post}${PASSWORD} | sed 's/\r//g'  >> ${plugin_tempfile}
cp -f ${plugin_tempfile} /tmp/budus_XDCC_db_${plugin_name}.dat

######################################################################
if [ ! -f "${plugin_tempfile}" ]; then
    echo > "${plugin_tempfile}"
    if [ ! -f "${plugin_tempfile}" ]; then
	echo "/ECHO %C4,1Non sono in grado di creare files temporanei in /tmp, problema di permessi ?"
	echo "/ECHO (${plugin_tempfile})"
	exit 1;
    else
	echo "/ECHO %C4,1Il plugin non e' stato in grado di generare il database. Segnalare il problema a UDA'Software, se persiste."
	exit 1;
    fi
fi

######################################################################
# Filtraggio
# L'output del filtro e' rappresentato da 8 campi separati dal
# carattere di tabulazione '\t', ovvero:
# NETWORK_NAME NETWORK_HOST CHANNEL BOT_NAME ID FILE_NAME SIZE COMMAND
#       1            2         3        4    5      6      7      8
######################################################################
filter_ONCLICK_generic 'DarkSin' 'irc.DarkSin.ch' '#ZooDyaCo'

make_data_file_exchange

######################################################################
rm -f ${plugin_tempfile}

######################################################################
echo "END  : $(basename $0) $*" >&2
######################################################################