#!/bin/bash

# Gestore dei Menu Esterni relativi a funzioni avanzate
# attivabili/disattivabili.

# Version 21/12/2011
# $Revision: 1.11 $
# By UDA'Software 2010

######################################################################
config_file=$HOME/.xchat2/buduscript/budus_external_menu.config

######################################################################
function get_var() {
    get_var=""
    
    if [ -f ${config_file} ]; then
	get_var=$(grep -F $1 ${config_file} | tail -n1 | awk '{print $2}')
    fi
    
    if [ "${get_var}" == "" ]; then
	get_var=$2
    fi
}

######################################################################
function load_config() {
    get_var AUDACIOUS_1_MENU 1
    AUDACIOUS_1_MENU=${get_var}
    
    get_var AUDACIOUS_2_MENU 1
    AUDACIOUS_2_MENU=${get_var}
    
    get_var AMAROK_MENU 1
    AMAROK_MENU=${get_var}
    
    get_var RHYTHMBOX_MENU 1
    RHYTHMBOX_MENU=${get_var}
    
    get_var EXAILE_MENU 1
    EXAILE_MENU=${get_var}
    
    get_var BANSHEE_MENU 1
    BANSHEE_MENU=${get_var}
    
    get_var LASTFM_MENU 1
    LASTFM_MENU=${get_var}
    
    get_var ESPEAK_MENU 1
    ESPEAK_MENU=${get_var}
    
    get_var XDCC_MENU 1
    XDCC_MENU=${get_var}
    
    printf '%s %s\n' AUDACIOUS_1_MENU ${AUDACIOUS_1_MENU} > ${config_file}
    printf '%s %s\n' AUDACIOUS_2_MENU ${AUDACIOUS_2_MENU} >> ${config_file}
    printf '%s %s\n' AMAROK_MENU ${AMAROK_MENU} >> ${config_file}
    printf '%s %s\n' RHYTHMBOX_MENU ${RHYTHMBOX_MENU} >> ${config_file}
    printf '%s %s\n' EXAILE_MENU ${EXAILE_MENU} >> ${config_file}
    printf '%s %s\n' BANSHEE_MENU ${BANSHEE_MENU} >> ${config_file}
    printf '%s %s\n' LASTFM_MENU ${LASTFM_MENU} >> ${config_file}
    printf '%s %s\n' ESPEAK_MENU ${ESPEAK_MENU} >> ${config_file}
    printf '%s %s\n' XDCC_MENU ${XDCC_MENU} >> ${config_file}
}

######################################################################
function load_menu__audacious() {
    if [ $(which audacious2 2> /dev/null) ]; then
	[ "${AUDACIOUS_2_MENU}" == 1 ] && echo "/budus macro buduscript_macro__audacious2"
    elif [ $(whichaudacious 2> /dev/null) ]; then
	[ "${AUDACIOUS_1_MENU}" == 1 ] && echo "/budus macro buduscript_macro__audacious"
    else
	echo "/ECHO ---%C8,1ATTENZIONE: Audacious non installato, non verra' aggiunto apposito menu."
	echo "ATTENZIONE: Audacious non installato, non verra' aggiunto apposito menu." >&2
    fi
}

function load_menu__amarok() {
    if [ $(which amarok 2> /dev/null) ]; then
	[ "${AMAROK_MENU}" == 1 ] && echo "/budus macro buduscript_macro__amarok"
    else
	echo "/ECHO ---%C8,1ATTENZIONE: Amarok non installato, non verra' aggiunto apposito menu."
	echo "ATTENZIONE: Amarok non installato, non verra' aggiunto apposito menu." >&2
    fi
}

function load_menu__rhythmbox() {
    if [ $(which rhythmbox-client 2> /dev/null) ]; then
	[ "${RHYTHMBOX_MENU}" == 1 ] && echo "/budus macro buduscript_macro__rhythmbox"
    else
	echo "/ECHO ---%C8,1ATTENZIONE: Rhythmbox non installato, non verra' aggiunto apposito menu."
	echo "ATTENZIONE: Rhythmbox non installato, non verra' aggiunto apposito menu." >&2
    fi
}

function load_menu__exaile() {
    if [ "$(which exaile 2> /dev/null)" != "" ]; then
	[ "${EXAILE_MENU}" == 1 ] && echo "/budus macro buduscript_macro__exaile"
    else
	echo "/ECHO ---%C8,1ATTENZIONE: Exaile non installato, non verra' aggiunto apposito menu."
	echo "ATTENZIONE: Exaile non installato, non verra' aggiunto apposito menu." >&2
    fi
}

function load_menu__banshee() {
    if [ $(which banshee 2> /dev/null) ]; then
	[ "${BANSHEE_MENU}" == 1 ] && echo "/budus macro buduscript_macro__banshee"
    else
	if [ $(which banshee-1 2> /dev/null) ]; then
	    echo "/ECHO ---%C8,1ATTENZIONE: Banshee installato, ma l'eseguibile ha un nome diverso dal previsto (banshee-1)."
	    echo "ATTENZIONE: Banshee installato, ma l'eseguibile ha un nome diverso dal previsto (banshee-1)." >&2
	    echo "/ECHO ---%C9,1            Se desideri utilizzarlo, devi creare un link simbolico, in modo che sia possibile lanciarlo anche tramite il comando 'banshee'."
	else
	    echo "/ECHO ---%C8,1ATTENZIONE: Banshee non installato, non verra' aggiunto apposito menu."
	    echo "ATTENZIONE: Banshee non installato, non verra' aggiunto apposito menu." >&2
	fi
    fi
}

function load_menu__lastfm() {
    if [ -f "${HOME}/.local/share/Last.fm/Last.fm.log" ]; then
	[ "${LASTFM_MENU}" == 1 ] && echo "/budus macro buduscript_macro__lastfm"
    else
	echo "/ECHO ---%C8,1ATTENZIONE: Last.fm non installato, non verra' aggiunto apposito menu."
	echo "ATTENZIONE: Last.fm non installato, non verra' aggiunto apposito menu." >&2
    fi
}

function load_menu__espeak() {
    if [ $(which espeak 2> /dev/null) ]; then
	[ "${ESPEAK_MENU}" == 1 ] && echo "/budus macro buduscript_macro__espeak"
    else
	echo "/ECHO ---%C8,1ATTENZIONE: eSpeak non installato, non verra' aggiunto apposito menu."
	echo "ATTENZIONE: eSpeak non installato, non verra' aggiunto apposito menu." >&2
    fi
}

######################################################################

command_type=${1}
[ "${command_type}" == "" ] && exit 1;

menu_name=${2}

######################################################################
case ${command_type} in
    LOAD_MENU)
	load_config
	
	# Carica i Comandi per Audacious
	load_menu__audacious
	
	# Carica i Comandi per Amarok
	load_menu__amarok
	
	# Carica i Comandi per Rhythmbox
	load_menu__rhythmbox
	
	# Carica i Comandi per Exaile
	load_menu__exaile
	
	# Carica i Comandi per banshee
	load_menu__banshee
	
	# Carica i Comandi per last.fm
	load_menu__lastfm
	
	# Carica i Comandi per eSpeak
	load_menu__espeak
	
	# Carica il XDCC Manager
	[ "${XDCC_MENU}" == 1 ] && echo "/budus macro xdcc MENU_PERSISTENT"
	
	;;
    MAKE_MENU)
	load_config
	
	if [ "$(audacious2 --version 2> /dev/null)" != "" ]; then
	    printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/Audacious 2" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE AUDACIOUS_2" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE AUDACIOUS_2"\n' "${AUDACIOUS_2_MENU}"
	elif [ "$(audacious --version 2> /dev/null)" != "" ]; then
	    printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/Audacious 1" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE AUDACIOUS_1" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE AUDACIOUS_1"\n' "${AUDACIOUS_1_MENU}"
	fi
	
	printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/Amarok" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE AMAROK" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE AMAROK"\n' "${AMAROK_MENU}"
	
	printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/Rhythmbox" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE RHYTHMBOX" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE RHYTHMBOX"\n' "${RHYTHMBOX_MENU}"
	
	printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/Exaile" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE EXAILE" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE EXAILE"\n' "${EXAILE_MENU}"
	
	printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/Banshee" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE BANSHEE" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE BANSHEE"\n' "${BANSHEE_MENU}"
	
	printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/Last.fm" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE LASTFM" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE LASTFM"\n' "${LASTFM_MENU}"
	
	printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/eSpeak" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE ESPEAK" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE ESPEAK"\n' "${ESPEAK_MENU}"
	
	printf '/MENU -t%d ADD "BuDuScRiPt/Preferenze/Gestione Menu Programmi Esterni/XDCC" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh ENABLE XDCC" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__external_menu.sh DISABLE XDCC"\n' "${XDCC_MENU}"
	;;
    ENABLE)
	case ${menu_name} in
	    AUDACIOUS_1)
		printf '%s %s\n' AUDACIOUS_1_MENU 1 >> ${config_file}
		AUDACIOUS_1_MENU=1
		load_menu__audacious
		;;
	    AUDACIOUS_2)
		printf '%s %s\n' AUDACIOUS_2_MENU 1 >> ${config_file}
		AUDACIOUS_2_MENU=1
		load_menu__audacious
		;;
	    AMAROK)
		printf '%s %s\n' AMAROK_MENU 1 >> ${config_file}
		AMAROK_MENU=1
		load_menu__amarok
		;;
	    RHYTHMBOX)
		printf '%s %s\n' RHYTHMBOX_MENU 1 >> ${config_file}
		RHYTHMBOX_MENU=1
		load_menu__rhythmbox
		;;
	    EXAILE)
		printf '%s %s\n' EXAILE_MENU 1 >> ${config_file}
		EXAILE_MENU=1
		load_menu__exaile
		;;
	    BANSHEE)
		printf '%s %s\n' BANSHEE_MENU 1 >> ${config_file}
		BANSHEE_MENU=1
		load_menu__banshee
		;;
	    LASTFM)
		printf '%s %s\n' LASTFM_MENU 1 >> ${config_file}
		LASTFM_MENU=1
		load_menu__lastfm
		;;
	    ESPEAK)
		printf '%s %s\n' ESPEAK_MENU 1 >> ${config_file}
		ESPEAK_MENU=1
		load_menu__espeak
		;;
	    XDCC)
		printf '%s %s\n' XDCC_MENU 1 >> ${config_file}
		echo "/budus macro xdcc MENU_PERSISTENT"
		;;
	    *)
		echo "/ECHO %C4,0%BERRORE INTERNO: buduscript_script__external_menu.sh :%C8,1 ENABLE: Menu ignoto."
		;;
	esac
	
	printf '/ECHO Menu%%B %s%%O Abilitato.\n' ${menu_name}
	load_config
	;;
    DISABLE)
	case ${menu_name} in
	    AUDACIOUS_1)
		printf '%s %s\n' AUDACIOUS_1_MENU 0 >> ${config_file}
		printf '/MENU DEL Audacious\n'
		;;
	    AUDACIOUS_2)
		printf '%s %s\n' AUDACIOUS_2_MENU 0 >> ${config_file}
		printf '/MENU DEL Audacious\n'
		;;
	    AMAROK)
		printf '%s %s\n' AMAROK_MENU 0 >> ${config_file}
		printf '/MENU DEL Amarok\n'
		;;
	    RHYTHMBOX)
		printf '%s %s\n' RHYTHMBOX_MENU 0 >> ${config_file}
		printf '/MENU DEL Rhythmbox\n'
		;;
	    EXAILE)
		printf '%s %s\n' EXAILE_MENU 0 >> ${config_file}
		printf '/MENU DEL Exaile\n'
		;;
	    BANSHEE)
		printf '%s %s\n' BANSHEE_MENU 0 >> ${config_file}
		printf '/MENU DEL Banshee\n'
		;;
	    LASTFM)
		printf '%s %s\n' LASTFM_MENU 0 >> ${config_file}
		printf '/MENU DEL Last.fm\n'
		;;
	    ESPEAK)
		printf '%s %s\n' ESPEAK_MENU 0 >> ${config_file}
		printf '/MENU DEL eSpeak\n'
		;;
	    XDCC)
		printf '%s %s\n' XDCC_MENU 0 >> ${config_file}
		echo "/budus macro xdcc UMENU"
		;;
	    *)
		echo "/ECHO %C4,0%BERRORE INTERNO: buduscript_script__external_menu.sh :%C8,1 ENABLE: Menu ignoto."
		;;
	esac
	
	printf '/ECHO Menu%%B %s%%O Disabilitato.\n' ${menu_name}
	load_config
	;;
    MAKE_DIALOG_BUTTONS)
	printf '/ECHO [MENU MANAGER]\t Verifica presenza pulsanti ...\n'
	dlgbuttons_conf="$HOME/.xchat2/dlgbuttons.conf"
	
	if [ "$(grep -Fi -e'NAME Monitoring' -e'NAME UnMonitoring' ${dlgbuttons_conf})" != "" ]; then
	    printf '/ECHO %%C4,1 ERRORE: I pulsanti sono stati aggiunti; riavviare XChat per rendere effettiva la modifica.\n'
	else
	    cat<<EOF >> ${dlgbuttons_conf}

NAME Monitoring
CMD budus qm

NAME UnMonitorin
CMD budus cmd /budus qm \ \;/budus CloseWindow()
EOF
	    
	    printf '/ECHO [MENU MANAGER]\t %%C3,1I pulsanti aggiunti sono permanenti e disponibili dal prossimo avvio di XChat; se si desidera rimuoverli, bisogna utilizzare apposita finestra di XChat dal menu: %%B%%C7,1Impostazioni -> Avanzate -> Pulsanti di dialogo ...\n'
	fi
	;;
    *)
	echo "/ECHO %C4,0%BERRORE INTERNO: buduscript_script__external_menu.sh :%C8,1 Comando non previsto."
	;;
esac

######################################################################
